<template>
  <div>
    <div>
      <el-container id="v4_main">
        <el-aside width="300px" v-if="$store.state.auth.jwt">
          <left-side-bar
            :recording="recording"
            :responseTime="responseTime"
            :pingErrorCount="pingErrorCount"
            @startRecord="startRecord"
            @stopRecord="stopRecord"
            @hello1="hello1">
          </left-side-bar>
        </el-aside>
        <el-main>
          <router-view :key="$route.fullPath"></router-view>
          <el-dialog :title="$t('HEADER.MY_ALARM_LIST')" align="center" :visible.sync="dialogStatusVisible" style="margin-right:10px;">
          <div style="height: 450px; overflow-y: scroll;">            
            <el-table :data="eventList" style="width: 95%" empty-text="알림이 없습니다.">
              <el-table-column
                prop="index"
                label='#'
                width="50"
                align="center">
                <template slot-scope="scope">
                  {{ scope.$index + 1 }}
                </template>
              </el-table-column>
              
              <el-table-column                
                prop="affiliation_name"
                :label="$t('ALARM_DIALOG.INSTITUTION_NAME')"
                width="100"
                align="center">
              </el-table-column>
              <el-table-column
                prop="discription"
                :label="$t('ALARM_DIALOG.CONTENTS')"
                width="400"
                align="center">
              </el-table-column>
              <el-table-column
                prop="created_at"
                :label="$t('ALARM_DIALOG.UPDATE_DATE')"
                align="center"
                >
              </el-table-column>
            </el-table>
            <br>
              <!-- TODO. 전부 삭제 추가 할 것-->
              <el-button @click="dialogStatusVisible = false">{{ $t('TEACHER_CLASS.CONFIRM') }}</el-button>
            <br />
            <br />
          </div>
        </el-dialog>          
          <el-dialog
            :title="$t('RECORD.SEND_RECORD_VIDEO')"
            :visible.sync="sendRecordingVisible"
            width="60%"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="beforeCloseDialog"
          >
            <h3>{{ $t("RECORD.CHECK_RECORD_VIDEO") }}</h3>
            <video ref="video" width="100%" controls></video>
            <h3 :style="{ marginTop: '40px' }">
              {{ $t("RECORD.RECORD_REASON") }}
            </h3>
            <el-input type="textarea" v-model="sendingReason" rows="10">
            </el-input>
            <el-button
              class="dialogButtons"
              type="primary"
              @click="sendRecord"
              >{{ $t("RECORD.SEND") }}</el-button
            >
            <el-button class="dialogButtons" @click="cancelRecord">{{
              $t("RECORD.CANCEL")
            }}</el-button>
          </el-dialog>
        </el-main>
      </el-container>
    </div> 
    <!-- <div v-else :id="$attachReactablePostfix('app')" :style="{ backgroundImage: ('url('+require('@/assets/study05.jpg')+')') }"
    :oncontextmenu="authType === 1 ? '' : 'return false'" :ondragstart="authType === 1 ? '' : 'return false'">
      <el-header :id="authType === 3 ? 'header_admin' : ''">
        <app-header
          :recording="recording"
          @startRecord="startRecord"
          @stopRecord="stopRecord"
        />
      </el-header>
      <el-container>
        <el-main
          :id="
            isMainPage
              ? 'app_router_view_wrapper_main'
              : 'app_router_view_wrapper'
          "
          :class="$attachReactablePostfix('elmain')"
        >
          <router-view :key="$route.fullPath"></router-view>
          <el-dialog
            :title="$t('RECORD.SEND_RECORD_VIDEO')"
            :visible.sync="sendRecordingVisible"
            width="60%"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="beforeCloseDialog"
          >
            <h3>{{ $t("RECORD.CHECK_RECORD_VIDEO") }}</h3>
            <video ref="video" width="100%" controls></video>
            <h3 :style="{ marginTop: '40px' }">
              {{ $t("RECORD.RECORD_REASON") }}
            </h3>
            <el-input type="textarea" v-model="sendingReason" rows="10">
            </el-input>
            <el-button
              class="dialogButtons"
              type="primary"
              @click="sendRecord"
              >{{ $t("RECORD.SEND") }}</el-button
            >
            <el-button class="dialogButtons" @click="cancelRecord">{{
              $t("RECORD.CANCEL")
            }}</el-button>
          </el-dialog>
        </el-main>
        <el-footer style="padding: 0px; height: 45px">
          <app-footer style="height: 45px" />
        </el-footer>
      </el-container>
    </div> -->
  </div>
</template>

<script>
import { mapState, mapMutations } from "vuex";
// import './app.scss';
// import './variables.scss'; // * To use $--color-primary scss variable

import AppNavigation from './components/layouts/AppNavigation';
import AppHeader from './components/layouts/NNAppHeader';
import AppFooter from './components/layouts/NNAppFooter';
import utils from './utils';
import recordService from './services/recordService';
import LeftSideBar from './components/layouts/LeftSideBar';
import userService from './services/userService';
import { pingUrl } from './services/config';

export default {
  name: "app",
  data() {
    return {
      teacherTheme: {
        background: "$app-ultra-violet",
      },
      dialogStatusVisible: false,
      pingErrorCount: 0,
      responseTime: 0,
      recorder: null,
      chunks: [],
      recording: false,
      sendRecordingVisible: false,
      sendingReason: "",
      recordingVideoSrc: "#",
      recordingResolution: {
        width: 960,
        height: 540,
      },
      recordingFrame: 5,
      
      // 21-05-14 현재 사용자의 이벤트 리스트 
      eventList: [],
      pingUpdateInterval: undefined,
    };
  },
  components: {
    AppNavigation,
    AppHeader,
    AppFooter,
    LeftSideBar,
  },
  computed: {
    ...mapState("layout", ["isNavCollapsed"]),
    isMainPage() {
      return this.$route.path === "/";
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    ...mapMutations("auth", ["updateJwt"]),
    
    // 21-05-14 이벤트 리스트를 호출한다.
    // eventNotificationList(){
    //   const vm = this;
    //   const userId = utils.getUserIdFromJwt();
    //   console.log(userId);

    //   //const result = userService.getUserEventNotificationList(userId);

    //   //console.log(result);
    // },
    
    async hello1() {
      const vm = this;
      vm.dialogStatusVisible = true;

      const userId = utils.getUserIdFromJwt();
      
      const result = await userService.getUserEventNotificationList(
        {
          userId : userId,
        }        
      );
      // console.log(result.data);      
      vm.eventList = result.data;

      console.log(vm.eventList);
    },
    hello2() {
      const vm = this;
      vm.dialogStatusVisible = false;
    },
    validateJwt() {
      const vm = this;
      const jwt = utils.getJwtFromLocalStorage();
      if (!jwt) {
        // * 로그인 안한 경우
        // * do nothing
      } else if (utils.isJwtExpired(jwt)) {
        // * 로그인은 했었는데 jwt 만료됨
        const redirect = confirm(vm.$t("NOTIFY.LOGIN_SESS_EXPIR")); // eslint-disable-line no-alert
        if (redirect) {
          vm.updateJwt({
            jwt: "",
          });
          vm.$router.push("/login");
        }
      }
    },
    cancelRecord(done) {
      const vm = this;
      vm.$confirm(
        vm.$t("RECORD.RECORD_SEND_CANCEL_MSG"),
        vm.$t("RECORD.RECORD_SEND_CANCEL"),
        {
          confirmButtonText: vm.$t("CONFIRM.YES_CANCEL"),
          cancelButtonText: vm.$t("CONFIRM.NO_CANCEL"),
          type: "warning",
        }
      )
        .then((_) => {
          typeof done === "Function" && done();
          vm.sendRecordingVisible = false;
          vm.$notify({
            title: vm.$t("RECORD.RECORD_SEND_CANCEL"),
            message: vm.$t("RECORD.CANCELED"),
            type: "success",
          });
        })
        .catch((_) => {});
    },
    async sendRecord() {
      const vm = this;
      //send record
      const loading = this.$loading({
        lock: true,
        text: vm.$t("RECORD.SENDING"),
        spinner: "el-icon-loading",
      });
      let result = null;
      let error = false;
      try {
        result = await recordService.postRecord({
          video: vm.recordingVideoSrc,
          comment: vm.sendingReason,
        });
      } catch (err) {
        error = true;
        vm.$notify({
          title: $t("RECORD.SENDING_ERROR"),
          message: err.toString(),
          type: "error",
          duration: 5000,
        });
      }
      loading.close();
      if (!error) {
        vm.sendingReason = "";
        vm.sendRecordingVisible = false;
        vm.$notify({
          title: vm.$t("RECORD.SEND_RECORD_VIDEO"),
          message: vm.$t("RECORD.SENT"),
          type: "success",
        });
      }
    },
    beforeCloseDialog(done) {
      const vm = this;
      vm.cancelRecord(done);
    },
    chromeChecker() {
      const result = utils.checkBrowser();
      if (result.name !== "chrome") {
        // eslint-disable-next-line
        const r = confirm(this.$t("CONFIRM.DWN_PAGE"));
        if (r === true) {
          window.open("https://www.google.co.kr/chrome/index.html", "_blank");
        }
      }
    },
    async startRecord() {
      const vm = this;
      try {
        vm.chunks = [];
        const stream = await navigator.mediaDevices.getDisplayMedia({
          video: {
            mediaSource: "screen",
            ...vm.recordingResolution,
            frameRate: { max: vm.recordingFrame },
          },
        });
        stream.getVideoTracks()[0].onended = vm.stopRecord;
        vm.recorder = new MediaRecorder(stream);
        vm.recorder.ondataavailable = (e) => vm.chunks.push(e.data);
        vm.recorder.start();
        vm.recorder.onstop = (e) => {
          const videoBlob = new Blob(vm.chunks, { type: vm.chunks[0].type });
          let reader = new FileReader();
          reader.readAsDataURL(videoBlob);
          reader.onloadend = () => {
            vm.$refs.video.addEventListener("loadedmetadata", (event) => {
              if (vm.$refs.video.duration === Infinity) {
                // set it to bigger than the actual duration
                vm.$refs.video.currentTime = 1e101;
                vm.$refs.video.ontimeupdate = function () {
                  this.ontimeupdate = () => {
                    return;
                  };
                  vm.$refs.video.currentTime = 0;
                };
              }
            });
            vm.recordingVideoSrc = reader.result.replace(
              `${reader.result.split(";")[0].split("/")[1]}`,
              "webm"
            );
            vm.$refs.video.src = vm.recordingVideoSrc;
          };
          stream.stop();
        };
        vm.recording = true;
        vm.$notify({
          title: vm.$t("RECORD.RECORD_START"),
          message: vm.$t("RECORD.RECORD_START_MSG"),
          type: "success",
          duration: 5000,
        });
      } catch (err) {
        const errorString = `${err}`;
        const errorTypes = [
          "AbortError",
          "InvalidStateError",
          "NotAllowedError",
          "NotFoundError",
          "NotReadableError",
          "OverconstrainedError",
          "TypeError",
        ];
        const errorType = errorTypes.findIndex((type) =>
          errorString.includes(type)
        );
        let message = "";

        switch (errorType) {
          case 0:
            message = `(${err}): An error or failure that doesn't match any of the other exceptions below occurred.`;
            break;

          case 1:
            message = `(${err}): The call to getDisplayMedia() was not made from code running due to a user action, such as an event handler. Another potential cause for this event: the document in whose context getDisplayMedia() was called is not fully active; for example, perhaps it is not the frontmost tab.`;
            break;

          case 2:
            message = vm.$t("RECORD.CANCELED");
            break;

          case 3:
            message = `(${err}): No sources of screen video are available for capture.`;
            break;

          case 4:
            message = `(${err}): The user selected a screen, window, tab, or other source of screen data, but a hardware or operating system level error or lockout occurred, preventing the sharing of the selected source.`;
            break;

          case 5:
            message = `(${err}): After creating the stream, applying the specified constraints fails because no compatible stream could be generated.`;
            break;

          case 6:
            //message = vm.$t('RECORD.ERROR');
            message = `(${err}): The specified constraints include constraints which are not permitted when calling getDisplayMedia(). These unsupported constraints are advanced and any constraints which in turn have a member named min or exact.`;
            break;

          default:
            message = `(${err})`;
        }
        // console.log('첫 설정을 안하신 경우에는 주소창에서 chrome://flags/#unsafely-treat-insecure-origin-as-secure 에 접속해서 Insecure origins treated as secure 을 enabled로 바꾸고 "http://preswottest.duckdns.org:8014/"를 입력해주세요 relaunch인가 버튼이 하단에 생깁니다 주소까지 입려한 후에 클릭해주세요.');
        vm.$notify({
          title: vm.$t("RECORD.RECORD_START"),
          message,
          type: "error",
          duration: 8000,
        });
      }
    },
    stopRecord() {
      const vm = this;
      vm.recorder && vm.recorder.stop();
      vm.recording = false;
      vm.sendRecordingVisible = true;
    },
  },
  async mounted() {
    const vm = this;
    vm.chromeChecker();
    vm.validateJwt();
    window.setInterval(() => {
      vm.validateJwt();
    }, 60 * 1000);
    vm.pingUpdateInterval = setInterval(() => {
      let startTime;
      const xhr = new XMLHttpRequest();
      
      xhr.open('GET', `${pingUrl}/ping/${Math.random().toFixed(2)}`);
      xhr.setRequestHeader('x-access-token', utils.getJwtFromLocalStorage());
      xhr.onload = _ => {
        vm.responseTime = new Date().getTime() - startTime;
        vm.pingErrorCount = 0;
      };
      xhr.onerror = err => {
        vm.pingErrorCount += 1;
      }
      startTime = new Date().getTime();
      xhr.send();
    }, 10000);
  },
  beforeDestroy() {
    const vm = this;
    clearInterval(vm.pingUpdateInterval);
  }
};
</script>

<style lang="scss">
@import "~@/app.scss";
@import "~@/variables.scss";

.elmain-phone {
  // FIXME: 강의중인 과목 목록에서, 빈 화면에 대고 좌우 스크롤하면 빈공간 나타나는 문제 임시 해결
  overflow: hidden;
}

#v4_main {
  min-height: 100vh;
}
.el-main {
  padding: 0;
}

#app {
  display: flex;
  flex-direction: column;
  min-height: 100vh;
}

#app-phone {
  display: flex;
  flex-direction: column;
  min-height: 100vh;
  background-size: cover;
}

#app_router_view_wrapper_main {
  flex: 1;
}

#app_router_view_wrapper {
  background-color: lighten($app-oatmeal, 50%);
  flex: 1;
}

#teacher_theme {
  // background-color: darken($app-ultra-violet, 10%);
  background-color: darken(#2497d8, 10%);
}

#teacher_lecture_live_theme {
  background-color: lighten($app-orange, 10%);
}

#student_theme {
  background-color: darken($--color-primary, 10%);
}

#default_theme {
  background-color: darken($--color-primary, 10%);
  /* sh s : png파일 문제*/
  /* background-color: rgba(0, 0, 0, 0.7); */
  /* background-color: rgba(0, 0, 0, 0); */
  /* box-shadow: 0 1px 2px rgba(0,0,0,0.9); */
  /*   background-image: url('https://cdn.zeplin.io/5b1f513665ca1be045ff097e/screens/8AB2F00A-8758-4DC0-B3AE-BF54C3A629F6.png'); */
  height: 100px;

  /* sh e */
}

#header_admin {
  z-index: 3;
}
.dialogButtons {
  position: relative;
  width: 80px;
  left: calc(100% - 175px);
  margin-top: 10px;
}
</style>
